package com.madeu.controller.web.webuserinquiry;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webuserinquiry.WebUserInquiryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;

@Slf4j
@Controller
public class WebUserInquiryController extends ManagerDraftAction {

    @Autowired
    private WebUserInquiryService webUserInquiryService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 1:1 문의 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webuserinquiry/selectListUserInquiryIntro.do")
    public String  selectListUserInquiryIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebUserInquiryController  selectListUserInquiryIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return "/web/login/logout";
            }
            else {
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webUserInquiryService.selectListUserInquiryIntro(paramMap);

                model.addAttribute("selectUseYn", map.get("selectUseYn"));
                model.addAttribute("insertUseYn", map.get("insertUseYn"));
                model.addAttribute("updateUseYn", map.get("updateUseYn"));
                model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
                model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebUserInquiryController  selectListUserInquiryIntro END");
        return "/web/appuserinquiry/appUserInquirySelectList";
    }
    /*
    * 1. selectlist - 문의 리스트 
    * 2. select - 문의 내용
    * 3. insert - 문의하기
    * 4. update - 답변하기/수정하기
    * */

    /**
     * 1:1 문의 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webuserinquiry/selectListAppUserInquiry.do")
    public ModelAndView selectListAppUserInquiry(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebUserInquiryController selectListAppUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webUserInquiryService.selectListAppUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebUserInquiryController selectListAppUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 1:1 문의정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webuserinquiry/selectAppUserInquiry.do")
    public ModelAndView selectAppUserInquiry(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebUserInquiryController selectAppUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webUserInquiryService.selectAppUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebUserInquiryController selectAppUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 1:1 문의 정보 등록 (고객 등록)
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webuserinquiry/insertAppUserInquiry.do")
    public ModelAndView insertAppUserInquiry(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
        log.debug("WebUserInquiryController insertAppUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webUserInquiryService.insertAppUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webuserinquiry/insertAppUserInquiry.do");
                insertMap.put("func", "insertAppUserInquiry");
                insertMap.put("funcName", "1:1 문의 등록");
                insertMap.put("service", "webUserInquiryService");
                insertMap.put("serviceName", "1:1 문의 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebUserInquiryController insertAppUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 1:1 문의 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webuserinquiry/updateAppUserInquiry.do")
    public ModelAndView updateAppUserInquiry(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
        log.debug("WebUserInquiryController updateAppUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!webCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("muMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
                map = webUserInquiryService.updateAppUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/webuserinquiry/updateAppUserInquiry.do");
                insertMap.put("func", "updateAppUserInquiry");
                insertMap.put("funcName", "1:1 문의 수정");
                insertMap.put("service", "webUserInquiryService");
                insertMap.put("serviceName", "1:1 문의 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("WebUserInquiryController updateAppUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

}
